unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, fpcsvexport, Forms, Controls, Graphics, Dialogs,
  DBGrids, StdCtrls, Math, fpsDataset, ZMConnection, ZMQueryDataSet;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CSVExporter1: TCSVExporter;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    sWorksheetDataset1: TsWorksheetDataset;
    QueryConnection1: TZMConnection;
    QueryDataSet1: TZMQueryDataSet;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

  TArray2D = array of array of double;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure ProcessArray(ADataSet: TDataSet; FieldNumber: integer;
  var a: array of double; var len: integer);
var
  AField: TField;
  AValue: double;
begin
  len := 0;
  AField := ADataSet.Fields[FieldNumber];
  ADataSet.First;
  while not ADataSet.EOF do
  begin
    //TryStrToFloat(AField.AsString, AValue);
    a[len] := StrToFloatDef(AField.AsString, 0.0);
    //a[len] := AValue;
    //ShowMessage(AField.AsString);
    Inc(len);
    ADataSet.Next;
  end;
end;

procedure SaveArray(n, m: integer; arr: TArray2D; filename: string);
const
  // separate by tab:
  separator = char(9);
var
  slInfo: TStringList;
  row, column: integer;
  line: string;
begin
  slInfo := TStringList.Create;
  for row := 0 to n - 1 do
  begin
    line := '';
    for column := 0 to m - 1 do
      line := line + FloatToStr(arr[row, column]) + separator;
    Delete(line, Length(Line), 1);
    slInfo.Add(line);
  end;
  slInfo.SaveToFile(filename);
  slInfo.Free;
end;


(*procedure SaveArray(n, m: integer; arr: TArray2D; filename: string);
var
  outfile: TextFile;
begin
  AssignFile(outfile, filename);
  Rewrite(outfile);
  for n := 0 to High(arr) - 1 do
  begin
    for m := 0 to High(arr[1]) - 1 do
      WriteLn(outfile, format('%d, %d', [n, m]));
    WriteLn(outfile);
  end;
  CloseFile(outfile);
end;*)

(*procedure GridToArray(kind: integer; var arr: TArray2D);
var
  SAMPLE, SPECIES: string;
  row, col: string;
  rows, cols: TStringList;
  nrows, ncols, i, j, freq: integer;
  bin: byte;
  found: boolean;
begin
  with Form1 do
  begin
    CSVExporter1.FileName := 'temp.csv';
    CSVExporter1.Execute;
    QueryConnection1.DatabasePath := GetCurrentDir;
    QueryConnection1.Connect;
    QueryDataSet1.TableName := 'temp';
    QueryDataset1.LoadFromTable;
    SAMPLE := QueryDataset1.Fields[0].FieldName;
    SPECIES := QueryDataset1.Fields[3].FieldName;
    QueryDataset1.SQL.Text :=
      'SELECT ' + SAMPLE + ' FROM temp GROUP BY ' + SAMPLE;
    QueryDataset1.QueryExecute;
    nrows := QueryDataset1.RecordCount;
    QueryDataset1.SQL.Text :=
      'SELECT ' + SPECIES + ' FROM temp GROUP BY ' + SPECIES;
    QueryDataset1.QueryExecute;
    ncols := QueryDataset1.RecordCount;
    QueryDataset1.SaveToTable;

    rows := TStringList.Create;
    rows.Sorted := True;
    rows.Duplicates := dupIgnore;
    sWorksheetDataset1.First;
    while not sWorksheetDataset1.EOF do
    begin
      rows.Add(sWorksheetDataset1.Fields[0].AsString);
      sWorksheetDataset1.Next;
    end;
    //ShowMessage(rows.DelimitedText);

    cols := TStringList.Create;
    cols.Sorted := True;
    cols.Duplicates := dupIgnore;
    sWorksheetDataset1.First;
    while not sWorksheetDataset1.EOF do
    begin
      cols.Add(sWorksheetDataset1.Fields[3].AsString);
      sWorksheetDataset1.Next;
    end;
    //ShowMessage(cols.DelimitedText);

    SetLength(arr, nrows, ncols);
    for i := 0 to nrows - 1 do
    begin
      row := rows[i];
      for j := 0 to ncols - 1 do
      begin
        col := cols[j];
        CSVExporter1.FileName := 'temp.csv';
        CSVExporter1.Execute;
        QueryConnection1.DatabasePath := GetCurrentDir;
        QueryConnection1.Connect;
        QueryDataSet1.TableName := 'temp';
        QueryDataset1.LoadFromTable;
        QueryDataset1.SQL.Text :=
          'SELECT COUNT(' + SPECIES + ') ' + ' FROM temp WHERE ' +
          SPECIES + ' = ' + QuotedStr(col) + ' AND ' + SAMPLE +
          ' = ' + QuotedStr(row);
        QueryDataset1.QueryExecute;
        {found := QueryDataset1.RecordCount > 0;
        if found then
          bin := 1
        else
          bin := 0;
        arr[i, j] := bin;}
        //freq := QueryDataset1.Fields[0].AsInteger;
        //arr[i, j] := freq;
        QueryDataset1.SaveToTable;
      end;
    end;

    SaveArray(nrows, ncols, arr, 'temp.txt');

    QueryConnection1.Disconnect;
  end;
  rows.Free;
  cols.Free;
  //ShowMessage(IntToStr(nrows) + ' row(s)' + LineEnding + IntToStr(ncols) + ' col(s)');
end;*)

procedure GridToArray(kind: integer; var arr: TArray2D);
var
  SAMPLE, SPECIES: string;
  masterKey, detailKey: string;
  //L: TStringList;
  r, c, counter: integer;
begin
  with Form1 do
  begin
    (*L := TStringList.Create;
    try
      L.Sorted := True;
      L.Duplicates := dupIgnore;
      sWorksheetDataset1.First;
      while not sWorksheetDataset1.EOF do
      begin
        L.Add(WorksheetDataset.FieldByName('PLOT').AsString);
        // Write list to first column of destination table
        //for i := 0 to L.Count-1 do
        //  destSheet.WriteText(i+1, 0, L[i]);
        sWorksheetDataset1.Next;
      end;
      L.Clear;
      sWorksheetDataset1.First;
      while not sWorksheetDataset1.EOF do
      begin
        L.Add(WorksheetDataset.FieldByName('SPECIES').AsString);
        // Write list to first row of destination table
        //for i := 0 to L.Count-1 do
        //  destSheet.WriteText(0, i+1, L[i]);
        sWorksheetDataset1.Next;
      end;
    finally
      L.Free;
    end;*)

    r := 0;
    c := 0;
    while not sWorksheetDataset1.EOF do
    begin
      masterKey := sWorksheetDataset1.FieldByName('PLOT').AsString;
      while not sWorksheetDataset1.EOF do
      begin
        detailKey := sWorksheetDataset1.FieldByName('SPECIES').AsString;
        // ... and count the occurrence of the cross-over cells in the source table
        counter := 0;
        while not sWorksheetDataset1.EOF do
        begin
          if sWorksheetDataset1.FieldByName('PLOT').AsString <> masterKey then
            continue;
          if sWorksheetDataset1.FieldByName('SPECIES').AsString <> detailKey then
            continue;
          Inc(counter);
          sWorksheetDataset1.Next;
        end;
        // ... store counter to destination array
        arr[r, c] := counter;
        Inc(c);
        sWorksheetDataset1.Next;
      end;
      Inc(r);
      SetLength(arr, r, c);
      sWorksheetDataset1.Next;
    end;

    //SaveArray(r, c, arr, 'temp.txt');
  end;
  //ShowMessage(IntToStr(r) + ' row(s)' + LineEnding + IntToStr(c) + ' col(s)');
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  sWorkSheetDataset1.Filename := 'PlantList.xls';
  sWorkSheetDataset1.AutoFieldDefs := True;
  sWorkSheetDataset1.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  arr: array of array of double;
begin
  GridToArray(1, arr);
end;

end.
